// ??????????? ??????????? ???????? ????????? ? AVR
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h> 

// ???????????? ????? 2 ????
// ??????????? ???????? ?? ??????? ???????
unsigned char cw_dir[12]= 
{
0b00000001,
0b00000010,
0b00000100,
0b00001000,
0b00000001,
0b00000010,
0b00000100,
0b00001000,
0b00000001,
0b00000010,
0b00000100,
0b00001000
};
unsigned char tsyfra[9]=
{
//0b00000000, //0
0b10110111,//0b11111001, //1
0b11000010,//0b10100100, //2
0b10010010,//0b10110000, //3
0b10110100,//0b10011001, //4
0b10011000,//0b10010010, //5
0b00011000,//0b10000010, //6
0b11010011,//0b11111000, //7
0b00010000,//0b10000000, //8
0b10010000,//0b10010000, //9
};

volatile unsigned char step_index, count_2, status;
volatile unsigned int ovftimes, step_limit, i;

// ?????????? ?? ???????????? ?0
ISR(TIMER0_OVF_vect)
{
static unsigned int count = 1;
count++;

if(count >= ovftimes) // ????????? ????????
{
cli(); // ????????? ??????????

count_2++; // ??????? ???-?? ?????

if(status) // ???? status = 1 ?????? ?????????
PORTC = cw_dir[step_index++];
else       // ????? ?????????????
PORTC = 0x00;

if(step_index >= 12)
{
step_index = 0;
}

if(count_2 > step_limit*12) // ???? ???-?? ????? ???????? ???????????? ????????(step_limit) ????????????? ?????????
{ 
status = 0;
}


if ((PIND&(1 << PD0)) == 0)                              
{
step_limit++;
//tsyfra [11] = tsyfra [i];
PORTB = tsyfra[++i];
}
if ((PIND&(1 << PD1)) == 0)                                                    
{
step_limit--;
PORTB = tsyfra[--i];
}

if (step_limit <=1)
{
step_limit = 1;
PORTB = tsyfra [0];
}
if (step_limit >=9)
{
step_limit = 9;
PORTB = tsyfra [8];
}


count = 0; // ????? ????????
TCNT0 = 0; // ????? ???????? ? ????
sei(); // ????????? ????????? ??????????
}
}


// ?????????? ?? ??????? INT0
ISR(INT0_vect)
{
status = 1; // ????????? ?????????
count_2 = 1;
}




int main(void)
{
DDRC = 0b00011110;
PORTC = 0x00;
//DDRB = 0b00001111; // PB0, PB1, PB2, PB3 - ??????
//PORTB = 0x00; // ???. ???? ?? ??????

DDRD = 0x00;
PORTD = 0xFF;

PORTB = 0x00;//0b0111111;
PORTB = 0x00;
//PORTC = 0b00111111;
//DDRC = 0xFF;

ADCSRA = (1 << ADEN) // ?????????? ???
      | (1 << ADPS2) // ???????????? ?? 64 (??????? ??? 125kHz)
	  | (1 << ADPS1);
ADMUX = 0x00; // ADC0 - ????, ??????? ??? 5 ?????

GICR |= (1 << INT0); // ????????? ??????? ??????????
MCUCR |= (1 << ISC01); // ?????????? ?? ??????? ?????? INT0

TCCR0 |= (1 << CS01); // ???????????? ?? 8
TCNT0 = 0; // ????? ???????? ? ????
TIMSK |= (1 << TOIE0); // ????????? ?????????? ?? ???????????? ?0

ovftimes = 10; // ?????????????? ????????

sei(); // ????????? ????????? ??????????



for (step_limit=1; (step_limit=step_limit);)  
{

ADCSRA |= (1 << ADSC); // ???????? ??????????????
while (ADCSRA & (1 << ADSC)); // ???? ???? ?????????? ??????????????
ovftimes = ADCW; // ???????? ????????? ????????

}
}
